/*
	ETTranscript.m
	
	Implements basic Smalltalk transcript functionality.
	
	Copyright (C) 2008 Günther Noack
 
	Author:  Günther Noack <guenther@unix-ag.uni-kl.de>
	Date:  November 2008
 
	Redistribution and use in source and binary forms, with or without
	modification, are permitted provided that the following conditions are met:

	* Redistributions of source code must retain the above copyright notice,
	  this list of conditions and the following disclaimer.
	* Redistributions in binary form must reproduce the above copyright notice,
	  this list of conditions and the following disclaimer in the documentation
	  and/or other materials provided with the distribution.
	* Neither the name of the Etoile project nor the names of its contributors
	  may be used to endorse or promote products derived from this software
	  without specific prior written permission.

	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
	AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
	ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
	LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
	CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
	SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
	INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
	CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
	THE POSSIBILITY OF SUCH DAMAGE.
 */


#import "ETTranscript.h"

#include <stdio.h>

/*
 * A simple transcript class.
 *
 * Design rationale:
 * While not a very nice implementation from the Objective-C
 * perspective, it has the advantage of being very similar to
 * the usual Transcript interface as seen in many Smalltalk
 * implementations.
 *
 * XXX: Possible refactoring: Allow to use different kinds of
 * transcript implementations through this class method
 * interface. (Factor out printfs, use delegation.)
 */
@implementation ETTranscript
+ (void) show: (NSObject*) anObject
{
  [self appendString: [anObject description]];
}

+ (void) appendString: (NSString*) aString
{
  printf("%s", [aString UTF8String]);
}

+ (void) cr
{
  putchar('\n');
}
@end

